<?php

require_once 'lang.php';

class ConfigUtils
{
    public static function load_config()
    {
        $lang_id = null;
        $widget_country = null;

        $lines = file("/config/settings.properties",
            FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
        foreach ($lines as $line)
        {
            if (preg_match('/^interface_language = (\S+)$/', $line, $matches))
            {
                $lang_id = $matches[1];
                hd_print("Using interface language: " . $lang_id);
            }
            if (preg_match('/^widget_country = (\S.*\S)\s*$/', $line, $matches))
            {
                $widget_country = $matches[1];
                hd_print("Using widget_country: " . $widget_country);
            }
        }

        if (!isset($lang_id))
            $lang_id = "english";

        $lang_code = Lang::get_code_by_id($lang_id);
        if (!isset($lang_code)) // should not happen
        {
            $lang_id = "english";
            $lang_code = "en";
        }

        if (!isset($widget_country))
            $widget_country = "";

        return (object) array(
            'lang_id' => $lang_id,
            'lang_code' => $lang_code,
            'widget_country' => $widget_country);
    }
}

?>
