<?php

class PathHelper
{
    public static function cmp_paths($path1, $path2)
    {
        $n1 = 0;
        $n2 = 0;
        for (;;)
        {
            $i1 = strpos($path1, '/', $n1);
            $i2 = strpos($path2, '/', $n2);

            $s1 = $i1 === false ?
                substr($path1, $n1) : substr($path1, $n1, $i1 - $n1);
            $s2 = $i2 === false ?
                substr($path2, $n2) : substr($path2, $n2, $i2 - $n2);

            // Indirect children before direct children (folders before
            // files).
            if ($i1 !== false && $i2 === false)
                return $s2 == '' ? 1 : -1;
            if ($i1 === false && $i2 !== false)
                return $s1 == '' ? -1 : 1;

            $res = strnatcasecmp($s1, $s2);
            if ($res != 0)
                return $res;

            if ($i1 === false)
                break;

            $n1 = $i1 + 1;
            $n2 = $i2 + 1;
        }

        return 0;
    }

    public static function path_to_array($path)
    {
        $len = strlen($path);
        if ($len == 0 || $path == '/')
            return array();
        if ($path[$len - 1] == '/')
            $path = substr($path, 0, $len - 1);
        if ($path[0] == '/')
            $path = substr($path, 1);
        return explode('/', $path);
    }
}

?>
